local addOn, ns = ...
local L =  ns.L

--[==[

	INVTYPE_HEAD -- голова
	INVTYPE_NECK -- нека
	INVTYPE_SHOULDER -- плечи
	INVTYPE_CLOAK -- плащик
	INVTYPE_ROBE -- грудак
	INVTYPE_BODY -- рубашка
	INVTYPE_WRIST -- запястие
	INVTYPE_HAND -- руки
	INVTYPE_WAIST -- пояс
	INVTYPE_LEGS -- ноги
	INVTYPE_FEET -- тапки
	INVTYPE_FINGER -- кольцо
	INVTYPE_TRINKET -- тринка

	INVTYPE_2HWEAPON -- палка
	INVTYPE_RANGED -- лук
	INVTYPE_WEAPON -- одноручка
	INVTYPE_RANGEDRIGHT -- ванда
	INVTYPE_SHIELD -- щит
	
	local itemID, altItemID, _, _, _, _, _, artifactAppearanceID, appearanceModID, itemAppearanceID, altItemAppearanceID, altOnTop = C_ArtifactUI.GetArtifactInfo()

	C_ArtifactUI.GetNumRelicSlots
	local lockedReason, relicName, relicIcon, relicLink = C_ArtifactUI.GetRelicInfo(relicSlotIndex);

	local relicName, relicIcon, relicType, relicLink = C_ArtifactUI.GetRelicInfoByItemID(itemID);

	local relicType = C_ArtifactUI.GetRelicSlotType(relicSlotIndex);

	IsArtifactRelicItem(itemID)

	C_ArtifactUI.CanApplyRelicItemIDToEquippedArtifactSlot(itemID, relicSlotIndex)
	local numRelicSlots = C_ArtifactUI.GetEquippedArtifactNumRelicSlots(true);
]==]

local strfind = strfind
local GetItemInfo = GetItemInfo

local currentClassCacheFilter
local enableFilterCache = false
local disableFilterCheck = false
local forceEnabledButtons = true

local pos = 'BOTTOM';
local FRAME_WIDTH, FRAME_HEIGHT = 328, 28
local RollBars = {}

local easyButtons = true
local blizzardStyle = false

local tinsert = table.insert
local match = string.match
local buttonsTexture = ns.buttonsTexture

local classSpecificItem = ITEM_CLASSES_ALLOWED:gsub('%%s', '(.+)')
ns.classSpecificItem = classSpecificItem

local mover = CreateFrame("Frame", nil, UIParent)
--mover:EnableMouse(true)
mover:SetMovable(true)
--mover:RegisterForDrag("LeftButton")
mover:SetPoint("CENTER", UIParent, "CENTER", 0,0)
mover:SetSize(FRAME_WIDTH+FRAME_HEIGHT, FRAME_HEIGHT)
--[[
mover.bg = mover:CreateTexture()
mover.bg:SetAllPoints()
mover.bg:SetTexture(0,0,0,0.6)
]]
mover:SetScript("OnDragStart", function()
	ns:StartClientSideMoving()
end)
mover:SetScript("OnDragStop", function()
	ns:StopClientSideMoving()
end)
--[[
mover.text = mover:CreateFontString()
mover.text:SetPoint("CENTER", mover, "CENTER", 0,0)
mover.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
mover.text:SetText('ClientSide Mover')	
]]
function ns:StartClientSideMoving()
	mover:StartMoving()
end
function ns:StopClientSideMoving()
	mover:StopMovingOrSizing()	
	local x, y = mover:GetCenter()
	local ux, uy = UIParent:GetCenter()
	ns.db.ClientSizeMover = { floor(x - ux + 0.5),floor(y - uy + 0.5) }
	ns:UpdateClientSizePosition()
end
function ns:UpdateClientSizePosition()
	mover:SetPoint("CENTER", UIParent, "CENTER", ns.db.ClientSizeMover[1] or 0, ns.db.ClientSizeMover[2] or 0)
end

do
	local linkItem = "\124cffa335ee\124Hitem:87777:0:0:0:0:0:0:0:0:0:0\124h[Reins of the Astral Cloud Serpent]\124h\124r"
	local mountSubclass = nil
	
	function ns.MountSubclassString(link)		
		local name, _, _, _, _, _, subclass = GetItemInfo(link)		
		mountSubclass = subclass
	end
	
	ns.QueueForItemInfo(linkItem, 'MountSubclassString')

	function ns.IsMountItem(subclass)
		return mountSubclass == subclass
	end
	
	function ns.IsMountExists(name)
		for i=1, C_MountJournal.GetNumMounts() do	
		--	print('T', C_MountJournal.GetMountInfo(i))	
			
		--	C_MountJournal.GetDisplayedMountInfo
			
			local creatureName, spellID, icon, _, _, _, _, _, _, _, isCollected = C_MountJournal[ ( ns.IsLegion and 'GetDisplayedMountInfo' or 'GetMountInfo')](i)
			
			if creatureName == name then		
				return isCollected
			end
		end
	end
end

do
	local hidegametooltip = CreateFrame("Frame")
	hidegametooltip:Hide()
	local gametooltip = CreateFrame("GameTooltip", addOn.."_GameToolTip", hidegametooltip, 'GameToolTipTemplate')
	gametooltip:SetScript('OnTooltipAddMoney', function()end)
	gametooltip:SetScript('OnTooltipCleared', function()end)
	gametooltip:SetScript('OnHide', function()end)
	gametooltip:SetScript('OnTooltipSetDefaultAnchor',function()end)
	gametooltip:SetOwner(hidegametooltip,"ANCHOR_NONE")
	
	local match = string.match
	
	function ns.GetItemID(link)
		local itemID = match(link, "|Hitem:(%-?%d+):")		
		if itemID then itemID = tonumber(itemID) end
		
		return itemID
	end

	function ns.CheckForContainTooltip(link, str)
	
		if not link then return end
		
		gametooltip:ClearLines()
		gametooltip:SetHyperlink(link)	
		
	--	print('T', 'CheckForContainTooltip', link)
		
		for i = 1, gametooltip:NumLines() do		
			local left = _G[gametooltip:GetName().."TextLeft"..i]:GetText()
			local right = _G[gametooltip:GetName().."TextRight"..i]:GetText()
			
			if left then
				local result = match(left, str)
				if result then
					
			--		print('T', 'CheckForContainTooltip', 'left', 'result', result, left)
					
					return result, left
				end
			end
			
			if right then
				local result = match(right, str)
				if result then
					
			--		print('T', 'CheckForContainTooltip', 'right', 'result', result, right)
					
					return result, right
				end
			end
		end
		
		return false
	end
	
	local classFinded = {}
	
	--[==[
	
		local numSpecs = GetNumSpecializationsForClassID(classID);
		for i = 1, numSpecs do
			local specID, specName = GetSpecializationInfoForClassID(classID, i, sex);
			
			
			
		function EncounterJournal_SetTooltip(link)
			local classID, specID = EJ_GetLootFilter();

			if (specID == 0) then
				local spec = GetSpecialization();
				if (spec and classID == select(3, UnitClass("player"))) then
					specID = GetSpecializationInfo(spec, nil, nil, nil, UnitSex("player"));
				else
					specID = -1;
				end
			end

			GameTooltip:SetHyperlink(link, classID, specID);
		end
		
		
		
		local checkForClass = ns.CheckForContainTooltip(link1, classSpecificItem)

		if checkForClass then
			local amount, list = ns.GetClassList(checkForClass)
			local playerClass = select(2, UnitClass('player'))
			
			print('T', amount, list, list[playerClass])
		end
	]==]
	
	function ns.GetPlayerClassInfo()
		
		local playerClass, classFileName, classIndex = UnitClass('player')
		
		local spec = GetSpecialization() or 0;
				
		local specID = GetSpecializationInfo(spec) or 0;
		
		return classIndex, specID, classFileName, playerClass
	end
	
	function ns.GetClassList(results)
		wipe(classFinded)
		local amount = 0
		
		for i=1, 15 do
			local className, classFile, index = GetClassInfoByID(i)
			if className then
				if match(results, className) then     
					amount = amount + 1
					classFinded[classFile] = index
				end       
			end      
		end
		
		return amount, classFinded
	end


end

local linkTypeItems = {	
	['INVTYPE_HEAD']         = { 1 }, -- голова
	['INVTYPE_NECK']         = { 2 },  -- нека
	['INVTYPE_SHOULDER']     = { 3 },  -- плечи
	['INVTYPE_CLOAK']        = { 15 },  -- плащик
	['INVTYPE_ROBE']         = { 5 },  -- грудак
	['INVTYPE_CHEST']		 = { 5 }, -- грудак без платья
	['INVTYPE_BODY']         = { 4 },  -- рубашка
	['INVTYPE_WRIST']        = { 9 },  -- запястие
	['INVTYPE_HAND']         = { 10 },  -- руки
	['INVTYPE_WAIST']        = { 6 },  -- пояс
	['INVTYPE_LEGS']         = { 7 }, -- ноги
	['INVTYPE_FEET']         = { 8 },  -- тапки
	['INVTYPE_FINGER']       = { 11, 12 },  -- кольцо
	['INVTYPE_TRINKET']      = { 13, 14 },  -- тринка
	['INVTYPE_2HWEAPON']     = { 16, 17 }, -- палка
	['INVTYPE_RANGED']       = { 16, 17 }, -- лук
	['INVTYPE_WEAPON']       = { 16, 17 }, -- одноручка
	['INVTYPE_RANGEDRIGHT']  = { 16, 17 }, -- ванда
	['INVTYPE_SHIELD']       = { 16, 17 }, -- щит
	['INVTYPE_HOLDABLE']	 = { 16, 17 }, -- оффхенд
}

ns.linkTypeItems = linkTypeItems

local tierTokenItemType = {
	-- HFC
	-- Head
	[127959] = 'INVTYPE_HEAD', -- Rogue, Death Knight, Mage, Druid 
	[127966] = 'INVTYPE_HEAD', -- Warrior, Hunter, Shaman, Monk
	[127956] = 'INVTYPE_HEAD', -- Paladin, Priest, Warlock
	
	-- Legs
	[127955] = 'INVTYPE_LEGS', -- Paladin, Priest, Warlock
	[127960] = 'INVTYPE_LEGS', -- Rogue, Death Knight, Mage, Druid
	[127965] = 'INVTYPE_LEGS', -- Warrior, Hunter, Shaman, Monk
	
	-- Hands
	[127954] = 'INVTYPE_HAND', -- Paladin, Priest, Warlock
	[127958] = 'INVTYPE_HAND', -- Rogue, Death Knight, Mage, Druid
	[127964] = 'INVTYPE_HAND', -- Warrior, Hunter, Shaman, Monk
	
	-- Shoulders
	[127967] = 'INVTYPE_SHOULDER',	-- Warrior, Hunter, Shaman, Monk
	[127961] = 'INVTYPE_SHOULDER', -- Rogue, Death Knight, Mage, Druid
	[127957] = 'INVTYPE_SHOULDER', -- Paladin, Priest, Warlock
	
	-- Chest
	[127962] = 'INVTYPE_CHEST', -- Rogue, Death Knight, Mage, Druid
	[127963] = 'INVTYPE_CHEST', -- Warrior, Hunter, Shaman, Monk
	[127953] = 'INVTYPE_CHEST', -- Paladin, Priest, Warlock

	-- Trinket
	[127970] = 'INVTYPE_TRINKET', -- Warrior, Hunter, Shaman, Monk
	[127968] = 'INVTYPE_TRINKET', -- Rogue, Death Knight, Mage, Druid
	[127969] = 'INVTYPE_TRINKET', -- Badge of Hellfire's Conqueror
}

do
	
	local MAIN_SPEC_ARG = 'mainspec'
	local OFF_SPEC_ARG = 'offspec'
	local BOTH_SPEC_ARG = 'bothspec'
	
	local ITEM_STAT_STRENGTH    = 'ITEM_MOD_STRENGTH_SHORT'
	local ITEM_STAT_AGILITY     = 'ITEM_MOD_AGILITY_SHORT'
	local ITEM_STAT_INTELLECT   = 'ITEM_MOD_INTELLECT_SHORT'
	
	local ITEM_STAT_STAMINA     = 'ITEM_MOD_STAMINA_SHORT'
	
	local ITEM_STAT_CRIT		= 'ITEM_MOD_CRIT_RATING_SHORT'
	local ITEM_STAT_MULTISTRIKE = 'ITEM_MOD_CR_MULTISTRIKE_SHORT'
	local ITEM_STAT_VERSATILITY = 'ITEM_MOD_VERSATILITY'
	local ITEM_STAT_HASTE 		= 'ITEM_MOD_HASTE_RATING_SHORT'
	local ITEM_STAT_MASTERY 	= 'ITEM_MOD_MASTERY_RATING_SHORT'
	
	local ITEM_STAT_SPELLPOWER	= 'ITEM_MOD_SPELL_POWER_SHORT'
	local ITEM_STAT_DPS			= 'ITEM_MOD_DAMAGE_PER_SECOND_SHORT'
	
--	local ITEM_STAT_SPIRIT		= 'ITEM_MOD_SPIRIT_SHORT'
--	local ITEM_STAT_BONUSARMOR  = 'RESISTANCE0_NAME'
	
--	local PATTERN_EXTRAARMOR	= "^+(%d-) "..ITEM_MOD_EXTRA_ARMOR_SHORT
	
	local ITEM_ARMOR_TYPE = nil
	
	local ITEM_ID_PLATE_ARMOR   = 8755
	local ITEM_ID_CLOTH_ARMOR   = 193
	local ITEM_ID_MAIL_ARMOR    = 2386
	local ITEM_ID_LEATHER_ARMOR = 85
	
	local ITEM_WEAPON_TYPE = nil
	
	local ITEM_ID_TWO_HANDED_SWORD   = 1412
	local ITEM_ID_TWO_HANDED_MACE    = 1414
	local ITEM_ID_TWO_HANDED_AXE     = 1417
	local ITEM_ID_TWO_HANDED_STAFF   = 1411
	local ITEM_ID_TWO_HANDED_POLEARM = 1485
	
	local ITEM_ID_ONE_HANDED_DAGGER    = 2138
	local ITEM_ID_ONE_HANDED_FIST	   = 15905
	local ITEM_ID_ONE_HANDED_AXE	   = 37
	local ITEM_ID_ONE_HANDED_MACE	   = 36
	local ITEM_ID_ONE_HANDED_SWORD	   = 2131
	local ITEM_ID_ONE_HANDED_WARGLAIVE = 140560
	
	local ITEM_ID_TWO_HANDED_BOW      = 2504
	local ITEM_ID_TWO_HANDED_CROSSBOW = 73211
	local ITEM_ID_TWO_HANDED_GUN      = 2510
	
	local ITEM_ID_ONE_HANDED_WAND = 5208
	
	local ITEM_ID_OFFHAND = 3421
	local ITEM_ID_SHIELD  = 2362

	local ARTIFACT_RELIC_TYPE_SHADOW = 'Shadow'
	local ARTIFACT_RELIC_TYPE_FEL = 'Fel'
	local ARTIFACT_RELIC_TYPE_IRON = 'Iron'
	local ARTIFACT_RELIC_TYPE_ARCANE = 'Arcane'
	local ARTIFACT_RELIC_TYPE_BLOOD = 'Blood'
	local ARTIFACT_RELIC_TYPE_FROST = 'Frost'
	local ARTIFACT_RELIC_TYPE_LIFE = 'Life'
	local ARTIFACT_RELIC_TYPE_STORM = 'Wind'
	local ARTIFACT_RELIC_TYPE_FIRE = 'Fire'
	local ARTIFACT_RELIC_TYPE_HOLY = 'Holy'
	
	--[[
		Death Knight 
			250 - Blood
			251 - Frost
			252 - Unholy
		Druid 
			102 - Balance
			103 - Feral Combat
			104 - Guardian
			105 - Restoration
		Hunter 
			253 - Beast Mastery
			254 - Marksmanship
			255 - Survival
		Mage 
			62 - Arcane
			63 - Fire
			64 - Frost
		Monk 
			268 - Brewmaster
			269 - Windwalker
			270 - Mistweaver
		Paladin 
			65 - Holy
			66 - Protection
			70 - Retribution
		Priest 
			256 Discipline
			257 Holy
			258 Shadow
		Rogue 
			259 - Assassination
			260 - Combat
			261 - Subtlety
		Shaman 
			262 - Elemental
			263 - Enhancement
			264 - Restoration
		Warlock 
			265 - Affliction
			266 - Demonology
			267 - Destruction
		Warrior 
			71 - Arms
			72 - Fury
			73 - Protection
			
		Demon Hunter
			577 - Havoc
			581 - Vengeance Tank
			
	]]
	
	--[==[
	
		EJ_SetDifficulty(difficulty)
		EJ_SelectInstance(instanceID)
		EJ_SelectEncounter(currentEncounterID)

		local _, _, classID = UnitClass('player')
		EJ_SetLootFilter(classID, GetLootSpecialization() or GetSpecializationInfo(GetSpecialization() or 0) or 0)
		
		
		for index = 1, EJ_GetNumLoot() do
		   local name, texture, slot, itemClass, itemID, itemLink, encounterID = EJ_GetLootInfoByIndex(index)
		   
		   print(index, name)
		end

	]==]
	
	--[==[
		
		124231 - Heal trinket 1st boss
		
		124223 - Agi dd trinket 2nd boss
		124227 - Int dd trinket 2nd boss
		
		124235 - Str dd trinket 3rd boss
		124239 - Tank trinket 3rd boss
		
		124224 - Agi dd trinket 4rd boss
		124228 - Caster dd/heal trinket 4rd boss
		
		124232 - Caster heal trinket 5th boss
		124240 - Tank 5boss
		
		124236 - Str 6boss
		
		124229 - Caster dps 7boss
		124241 - Tank 7boss
		
		124233 - Heal trinket 
		124225 - Agi dps trinket melee
		
		124237 - Str dps
		
		124234 - Heal trink
		
		124226 - Agi trinket
		124242 - Tank trinket
		
		124230 - Caster
		124238 - Str dps
		
		
		
		124242 - Tank trinket
		124241 - Tank 7boss
		124240 - Tank 5boss
		124239 - Tank trinket 3rd boss
					
		124223 - Agi dd trinket 2nd boss
		124226 - Agi trinket
		124225 - Agi dps trinket melee
		124224 - Agi dd trinket 4rd boss
		
		124238 - Str dps
		124237 - Str dps
		124236 - Str 6boss
		124235 - Str dd trinket 3rd boss
		
		124230 - Caster
		124229 - Caster dps 7boss
		124228 - Caster dd/heal trinket 4rd boss
		124227 - Int dd trinket 2nd boss
		
		124234 - Heal trink
		124233 - Heal trinket
		124232 - Caster heal trinket 5th boss
		124231 - Heal trinket 1st boss
		124228 - Caster dd/heal trinket 4rd boss
		
		Emerald Nightmare
		
			Низендра
		139320 -- Танк тринкет?
		139321 -- Кастер дд
		
			Илгинот
		139325 -- Мили
		139326 -- Кастер
		139324 -- Танк
		
			Элерен
		139323 -- Кастер+Агила
		139322 -- Хил тринк
		
			Урсок
		139329 -- Агила тринк
		139327 -- Танк
		139330 -- Хил
		139328 -- Сили дд тринк
		
			Драконы
		138224 -- Кастер дд
		138225 -- Танк тринк
		138222 -- Хил тринк
		
			Кенарий
		139334 -- Мили тринк
		139333 -- Танк тринк
		
			Ксавий
		139336 -- Кастер дд
		139335 -- Танк Тринкет
	]==]
	
	local TRINKET_AGILITY = 'AGI'
	local TRINKET_STRENGTH = 'STR'
	local TRINKET_INTELLECT = 'INT'
	local TRINKET_HEAL = 'HEAL'
	local TRINKET_TANK = 'TANK'
	local TRINKET_DAMAGE = 'DD'
	
	local TRINKET_MELEE = 'MELEE'
	local TRINKET_RANGED = 'RANGED'
	
	local TRINKET_AGILITY_DAMAGE = TRINKET_AGILITY..' '..TRINKET_DAMAGE
	local TRINKET_STRENGTH_DAMAGE = TRINKET_STRENGTH..' '..TRINKET_DAMAGE
	local TRINKET_INTELLECT_DAMAGE = TRINKET_INTELLECT..' '..TRINKET_DAMAGE
	
	local trinketList = {	
		--	Агила дд
		[139334] = TRINKET_AGILITY_DAMAGE,
		[139325] = TRINKET_AGILITY_DAMAGE,
		[139323] = TRINKET_INTELLECT_DAMAGE..' '..TRINKET_AGILITY_DAMAGE, -- Ветерки Агила+Инта+дд
		[139329] = TRINKET_AGILITY_DAMAGE,
		[139320] = TRINKET_AGILITY_DAMAGE,
		--	Сила дд
		[139334] = TRINKET_STRENGTH_DAMAGE,
		[139325] = TRINKET_STRENGTH_DAMAGE,
		[139328] = TRINKET_STRENGTH_DAMAGE,
		[139329] = TRINKET_STRENGTH_DAMAGE,
		[139320] = TRINKET_STRENGTH_DAMAGE,
		
		[142508] = TRINKET_STRENGTH_DAMAGE..' '..TRINKET_TANK,
		[142506] = TRINKET_AGILITY_DAMAGE..' '..TRINKET_TANK,
		[142507] = TRINKET_INTELLECT_DAMAGE..' '..TRINKET_HEAL,
		
		--	Кастер дд
		[139321] = TRINKET_INTELLECT_DAMAGE,
		[139326] = TRINKET_INTELLECT_DAMAGE,
		[138224] = TRINKET_INTELLECT_DAMAGE,
		[139336] = TRINKET_INTELLECT_DAMAGE,		
		--	Хил
		[139322] = TRINKET_HEAL,
		[139330] = TRINKET_HEAL,
		[138222] = TRINKET_HEAL,
		
		--	Танк
		[139324] = TRINKET_TANK,
		[139327] = TRINKET_TANK,
		[138225] = TRINKET_TANK,
		[139335] = TRINKET_TANK,
	}
	
	-- 1 2 3 4 5 6 7 8 9 10
	-- 1 - 1 2
	-- 2 - 3 4
	-- 3 - 5 6
	-- 4 - 7 8
	-- 5 - 9 10
	local function GetTrinketList(...)
		local t = {}
		local num = select('#', ...)
		local index = 0
		
		for i=1, num/2 do
			index = index + 1
			local arg1 = select(index, ...)
			
			index = index + 1
			local arg2 = select(index, ...)
			
		--	print('T', i, arg1, arg2)
			
			for id, vals in pairs(trinketList) do
		--		print('T2', id, vals, string.find(vals, arg1))
				if string.find(vals, arg1) then
					if t[id] then
						if t[id] ~= arg2 then
							t[id] = BOTH_SPEC_ARG
						end
					else
						t[id] = arg2
					end
				end
			end
		end
		
		return t
	end
	
	ns.GetTrinketList = GetTrinketList

	local classSpecificFilter = {
		['DEMONHUNTER'] = {
			[577] = {
				['isTank'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_WARGLAIVE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,OFF_SPEC_ARG, TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = { 
					[ARTIFACT_RELIC_TYPE_SHADOW] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
				},
			},
			[581] = {
				['isTank'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_WARGLAIVE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,MAIN_SPEC_ARG,TRINKET_AGILITY_DAMAGE,OFF_SPEC_ARG),
				['ARTIFACT'] = { 					
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = MAIN_SPEC_ARG,				
				},
			},		
		},
		['DEATHKNIGHT'] = {
			[250] = { 
				['isTank'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = MAIN_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_MACE]  = MAIN_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_AXE]   = MAIN_SPEC_ARG,
					
					[ITEM_ID_ONE_HANDED_AXE]   = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE]  = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = OFF_SPEC_ARG,
					
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG, 
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,MAIN_SPEC_ARG,TRINKET_STRENGTH_DAMAGE,OFF_SPEC_ARG),
				['ARTIFACT'] = { 
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			},
			[251] = { 
				['isTank'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = OFF_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_MACE]  = OFF_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_AXE]   = OFF_SPEC_ARG,
					
					[ITEM_ID_ONE_HANDED_AXE]   = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE]  = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG, 
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,OFF_SPEC_ARG,TRINKET_STRENGTH_DAMAGE,MAIN_SPEC_ARG),
				['ARTIFACT'] = { 
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			},
			[252] = { 
				['isTank'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = MAIN_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_MACE]  = MAIN_SPEC_ARG,					
					[ITEM_ID_TWO_HANDED_AXE]   = MAIN_SPEC_ARG,
					
					[ITEM_ID_ONE_HANDED_AXE]   = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE]  = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = OFF_SPEC_ARG,
					
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG, 
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,OFF_SPEC_ARG,TRINKET_STRENGTH_DAMAGE,MAIN_SPEC_ARG),
				['ARTIFACT'] = { 
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
				},
			},
		},
		['DRUID'] = {
			[102] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
					[ITEM_STAT_AGILITY] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,			   OFF_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Balance
			[103] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,			   OFF_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Feral Combat
			[104] = {
				['isTank'] = MAIN_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,	MAIN_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
				},
			}, -- Guardian
			[105] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
					[ITEM_STAT_AGILITY] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK,	OFF_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Restoration
		},
		['HUNTER'] = {
			[253] = {
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_BOW] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_CROSSBOW] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_GUN] = MAIN_SPEC_ARG,
					
					[ITEM_ID_TWO_HANDED_STAFF] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = BOTH_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
				},
			}, -- Beast Mastery
			[254] = {
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_BOW] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_CROSSBOW] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_GUN] = MAIN_SPEC_ARG,
		
					[ITEM_ID_TWO_HANDED_STAFF] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = BOTH_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,			
				},
			}, -- Marksmanship
			[255] = {
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					
					[ITEM_ID_TWO_HANDED_BOW] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_CROSSBOW] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_GUN] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = BOTH_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = { 
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
				},
			}, -- Survival
		},
		['MAGE'] = { 
			[62] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_ARCANE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Arcane
			[63] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
				},
			}, -- Fire
			[64] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Frost
		},
		['MONK'] = {
			[268] = {
				['isTank'] = MAIN_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, MAIN_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
				},
			}, -- Brewmaster
			[269] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, OFF_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
				},
			}, -- Windwalker
			[270] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = OFF_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, OFF_SPEC_ARG,
											  TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = MAIN_SPEC_ARG,
				},
			}, -- Mistweaver
		},
		['PALADIN'] = { 
			[65] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['useShield'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = OFF_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, OFF_SPEC_ARG,
											  TRINKET_STRENGTH_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_HOLY] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Holy
			[66] = {
				['isTank'] = MAIN_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['useShield'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, MAIN_SPEC_ARG,
											  TRINKET_STRENGTH_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_HOLY] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
				},
			}, -- Protection
			[70] = {
				['isTank'] = OFF_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['isCaster'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['useShield'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = BOTH_SPEC_ARG,
					
					[ITEM_ID_ONE_HANDED_MACE] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG,
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_TANK, OFF_SPEC_ARG,
											  TRINKET_STRENGTH_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_HOLY] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_ARCANE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
				},
			}, -- Retribution
		},
		['PRIEST'] = { 
			[256] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, BOTH_SPEC_ARG,
											  TRINKET_HEAL, BOTH_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_HOLY] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
				},
			}, -- Discipline
			[257] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, MAIN_SPEC_ARG),
				['ARTIFACT'] = {	
					[ARTIFACT_RELIC_TYPE_HOLY] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,
				},
			}, -- Holy
			[258] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_HOLY] = OFF_SPEC_ARG,
				},
			}, -- Shadow
		},
		['ROGUE'] = {
			[259] = {
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = OFF_SPEC_ARG,},
			}, -- Assassination
			[260] = {
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,
				},
			}, -- Combat
			[261] = {
				['ARMOR']    = { 
					[ITEM_ID_LEATHER_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FEL] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
				},
			}, -- Subtlety
		},
		['SHAMAN'] = {
			[262] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['useShield'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
					[ITEM_STAT_AGILITY] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
				},
			}, -- Elemental
			[263] = {
				['isCaster'] = OFF_SPEC_ARG,
				['isHealer'] = OFF_SPEC_ARG,
				['useOffhand'] = OFF_SPEC_ARG,
				['useShield'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = OFF_SPEC_ARG,
					[ITEM_STAT_AGILITY] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FROST] = OFF_SPEC_ARG,
				},
			}, -- Enhancement
			[264] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['isHealer'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['useShield'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_MAIL_ARMOR] = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_FIST] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = BOTH_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = BOTH_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
					[ITEM_STAT_AGILITY] = OFF_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_AGILITY_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_INTELLECT_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_HEAL, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FROST] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_LIFE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = OFF_SPEC_ARG,
				},
			}, -- Restoration
		},
		['WARLOCK'] = {
			[265] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,},
			}, -- Affliction
			[266] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_SHADOW] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FEL] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,},
			}, -- Demonology
			[267] = {
				['isCaster'] = MAIN_SPEC_ARG,
				['useOffhand'] = MAIN_SPEC_ARG, 
				['ARMOR']    = { 
					[ITEM_ID_CLOTH_ARMOR]  = MAIN_SPEC_ARG,
				},
				['WEAPON']   = { 
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_WAND] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_INTELLECT] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_INTELLECT_DAMAGE, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FEL] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,},
			}, -- Destruction
		},
		['WARRIOR'] = {
			[71] = {
				['useShield'] = OFF_SPEC_ARG,
				['isTank'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = OFF_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG, 
				},
				['TRINKETS'] = GetTrinketList(TRINKET_STRENGTH_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_TANK, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = OFF_SPEC_ARG,
				},
			}, -- Arms
			[72] = {
				['useShield'] = OFF_SPEC_ARG,
				['isTank'] = OFF_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = MAIN_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_STRENGTH_DAMAGE, MAIN_SPEC_ARG,
											  TRINKET_TANK, OFF_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = OFF_SPEC_ARG,
				},
			}, -- Fury
			[73] = {
				['useShield'] = MAIN_SPEC_ARG,
				['isTank'] = MAIN_SPEC_ARG,
				['ARMOR']    = { 
					[ITEM_ID_PLATE_ARMOR] = MAIN_SPEC_ARG
				},
				['WEAPON']   = { 
					[ITEM_ID_TWO_HANDED_SWORD] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_MACE] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_AXE] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_STAFF] = OFF_SPEC_ARG,
					[ITEM_ID_TWO_HANDED_POLEARM] = OFF_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_DAGGER] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_FIST] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_SWORD] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_AXE] = MAIN_SPEC_ARG,
					[ITEM_ID_ONE_HANDED_MACE] = MAIN_SPEC_ARG,
				},
				['STATS']    = { 
					[ITEM_STAT_STRENGTH] = MAIN_SPEC_ARG,
				},
				['TRINKETS'] = GetTrinketList(TRINKET_STRENGTH_DAMAGE, OFF_SPEC_ARG,
											  TRINKET_TANK, MAIN_SPEC_ARG),
				['ARTIFACT'] = {
					[ARTIFACT_RELIC_TYPE_IRON] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_BLOOD] = BOTH_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_FIRE] = MAIN_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_SHADOW] = OFF_SPEC_ARG,
					[ARTIFACT_RELIC_TYPE_STORM] = OFF_SPEC_ARG,
				},
			}, -- Protection
		},
	}
	
	local relicToClassSpec = {}
	local relicToClassSpec_Strings = {}
	for class, specs in pairs(classSpecificFilter) do				
		for spec in pairs(specs) do					
			for relicType, specArg in pairs(specs[spec]['ARTIFACT']) do
				if specArg ~= OFF_SPEC_ARG then
					relicToClassSpec[relicType] = relicToClassSpec[relicType] or {}
					relicToClassSpec[relicType][class] = relicToClassSpec[relicType][class] or {}
					relicToClassSpec[relicType][class][spec] = true
				end
			end
		end
	end
	
	local relicInfoFrame = CreateFrame('Frame')
	relicInfoFrame:SetSize(200, 50)
	relicInfoFrame.text = relicInfoFrame:CreateFontString()
	relicInfoFrame.text:SetFont(STANDARD_TEXT_FONT, 14, 'NONE')
	relicInfoFrame.text:SetPoint('TOPLEFT', relicInfoFrame, 'TOPLEFT', 3, -3)
	relicInfoFrame.text:SetJustifyH('LEFT')
	relicInfoFrame.text:SetJustifyV('TOP')
	relicInfoFrame.text:SetDrawLayer('OVERLAY')
	
	relicInfoFrame.bg = relicInfoFrame:CreateTexture()
	relicInfoFrame.bg:SetPoint('TOPLEFT', relicInfoFrame, 'TOPLEFT', -1, 1)
	relicInfoFrame.bg:SetPoint('BOTTOMRIGHT', relicInfoFrame, 'BOTTOMRIGHT', 1, -1)
	relicInfoFrame.bg:SetDrawLayer('OVERLAY')
	relicInfoFrame.bg:SetColorTexture(0,0,0,0.9)
	
	function ns.GetRelicClassSpec(itemID, tooltip)
	
		if not ns.db.relicTooltipInfoHelp then
			ns.HideRelicInfoFrame()
			return
		end
	
		local relicName, relicIcon, relicType, relicLink = C_ArtifactUI.GetRelicInfoByItemID(itemID);	
	
		if not relicToClassSpec_Strings[relicType] then
			relicToClassSpec_Strings[relicType] = {}
			
	--		relicToClassSpec_Strings[relicType][#relicToClassSpec_Strings[relicType]+1] = '\n'
			for class, specs in pairs(relicToClassSpec[relicType]) do
				
				local className, classFile, index, colorStr = ns.GetClassInfo( class )
				local t = '|c'..colorStr..className..'|r:'
				for specID in pairs(specs) do
					local texture = ns.GetSpecClassString(index, specID)
					t = t.."|T"..texture..":10:10:0:0:64:64:4:60:4:60|t "
				end
				
				relicToClassSpec_Strings[relicType][#relicToClassSpec_Strings[relicType]+1] = t
			end
			
		--	relicToClassSpec_Strings[relicType][#relicToClassSpec_Strings[relicType]+1] = '\n'
		end
		
		local text = ''
		local height = 6
		for i=1, #relicToClassSpec_Strings[relicType] do
			text = text..relicToClassSpec_Strings[relicType][i].. ( i==#relicToClassSpec_Strings[relicType] and '' or '\n' )
			height = height+14
		end
	
		relicInfoFrame.text:SetText(text)
		relicInfoFrame:Show()
		
		relicInfoFrame:SetParent(tooltip)
		relicInfoFrame:SetPoint('TOPLEFT', tooltip, 'BOTTOMLEFT', 0, -3)
		relicInfoFrame:SetWidth(tooltip:GetWidth())
		relicInfoFrame:SetHeight(height)
	end
	
	function ns.HideRelicInfoFrame()
		relicInfoFrame:Hide()		
	end
	
	local classItemFiler = {}
	
	function ns.QueueForClassItemFilter(itemID, spec, itemType, specType)
		local name, link, _, _, _, class, subclass = GetItemInfo(itemID)
		
		--[==[
		if itemType == 'WEAPON' and ITEM_WEAPON_TYPE == nil then
			ITEM_WEAPON_TYPE = class
		elseif itemType == 'ARMOR' and ITEM_ARMOR_TYPE == nil then
			ITEM_ARMOR_TYPE = class		
		end
		]==]
		
		classItemFiler[spec][itemType][subclass] = specType
	end
	
	function ns.BuildClassItemFilter()
	
		local classIndex, specID, classFileName, playerClass = ns.GetPlayerClassInfo()
		
		if enableFilterCache then
			if specID and specID > 0 then
				if not ns.db.lootFilterCache[classFileName] then ns.db.lootFilterCache[classFileName] = {} end
				if not ns.db.lootFilterCache[classFileName][specID] then ns.db.lootFilterCache[classFileName][specID] = {} end
				currentClassCacheFilter = ns.db.lootFilterCache[classFileName][specID]
			end
		else
			wipe(ns.db.lootFilterCache)
		end
		
		for spec, data in pairs(classSpecificFilter[classFileName]) do
			
			if not classItemFiler[spec] then
				classItemFiler[spec] = {}
			end
	
			for itemID, specType in pairs(data['ARMOR']) do			
				
				if not classItemFiler[spec]['ARMOR'] then
					classItemFiler[spec]['ARMOR'] = {}
				end
				
				ns.QueueForItemInfo(itemID, 'QueueForClassItemFilter', spec, 'ARMOR', specType)	
			end
			
			for itemID, specType in pairs(data['WEAPON']) do
				
				if not classItemFiler[spec]['WEAPON'] then
					classItemFiler[spec]['WEAPON'] = {}
				end
				
				ns.QueueForItemInfo(itemID, 'QueueForClassItemFilter', spec, 'WEAPON', specType)	
			end
			
		end
	end
	
	local singeStatsType = {
		['INVTYPE_TRINKET'] = true,
		['INVTYPE_2HWEAPON'] = true,
		['INVTYPE_RANGED'] = true,
		['INVTYPE_WEAPON'] = true,
		['INVTYPE_RANGEDRIGHT'] = true,
	}
	--[==[
		['useOffhand'] = MAIN_SPEC_ARG,
		['useShield'] = MAIN_SPEC_ARG,
		['isCaster'] = MAIN_SPEC_ARG,
	]==]
	
	local itemStatCache = {}
	
	local function CheckMainStat(statList, noMainStat)
	
		local main, off = false, false
		local hasMainStats = itemStatCache[ITEM_STAT_STRENGTH] or itemStatCache[ITEM_STAT_AGILITY] or itemStatCache[ITEM_STAT_INTELLECT] or false
		
		for stat, specArg in pairs(statList) do
			if hasMainStats and itemStatCache[stat] then			
				if specArg == BOTH_SPEC_ARG then
					main = true
					off = true
				else				
					if specArg == MAIN_SPEC_ARG then
						main = true
					end
					if specArg == OFF_SPEC_ARG then
						off = true
					end
				end
			elseif noMainStat and not hasMainStats then
				main = true
				off = true
			end
		end
		
		return main, off
	end
	
	local function CheckSpecArgs( arg1, arg2 )
		if arg1 == BOTH_SPEC_ARG then
			return true
		end
		
		return arg1 == arg2
	end
	
	function ns.CheckItemFilter(link) -- enableNeed, enableOffspec, enableTransmog
		if not link then return 'error1' end
		if disableFilterCheck then return true, true, true end
		
		local name, link1, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(link)		
		
		if not name then return 'error2' end
				
		local classIndex, specID, classFileName, playerClass = ns.GetPlayerClassInfo()
		local itemID = ns.GetItemID(link1)
		
		if enableFilterCache and currentClassCacheFilter and currentClassCacheFilter[itemID] then
			return currentClassCacheFilter[itemID][1], 
					currentClassCacheFilter[itemID][2], 
					currentClassCacheFilter[itemID][3]
		end
			
			
			
		local checkForClass = ns.CheckForContainTooltip(link1, ns.classSpecificItem)

		if checkForClass then
			local amount, list = ns.GetClassList(checkForClass)
			if amount > 0 then
			
				if not list[classFileName] then
					return false, false, false
				end
			end
		end
		
		if IsArtifactRelicItem(itemID) then
			local relicName, relicIcon, relicType, relicLink = C_ArtifactUI.GetRelicInfoByItemID(itemID);
			local specArg = classSpecificFilter[classFileName][specID]['ARTIFACT'][relicType]
			
			if specArg then			
				return CheckSpecArgs( specArg, MAIN_SPEC_ARG ), CheckSpecArgs( specArg, OFF_SPEC_ARG ), false
			end
			
			return false, false, false
		end
		
		local fullCSF = classSpecificFilter[classFileName][specID]
		
		if equipSlot == 'INVTYPE_TRINKET' then
			
			if trinketList[itemID] then
				if fullCSF['TRINKETS'][itemID] then			
					return CheckSpecArgs( fullCSF['TRINKETS'][itemID], MAIN_SPEC_ARG ), CheckSpecArgs( fullCSF['TRINKETS'][itemID], OFF_SPEC_ARG ), false
				end
				return false, false, false
			else
				return true, true, false
			end
		elseif equipSlot == 'INVTYPE_2HWEAPON' or
				equipSlot == 'INVTYPE_RANGED' or
				equipSlot == 'INVTYPE_WEAPON' or
				equipSlot == 'INVTYPE_RANGEDRIGHT' then
			
				if classItemFiler[specID]['WEAPON'][subclass] then
					local specArg = classItemFiler[specID]['WEAPON'][subclass]
					
					wipe(itemStatCache)
					GetItemStats(link1, itemStatCache)
					local hasMainStat, hasOffspecStat = CheckMainStat(fullCSF['STATS'])
					
			--		print('T1', 'CheckMainStat', hasMainStat, hasOffspecStat)
			--		print('T2', 'isCaster', fullCSF.isCaster)
					if fullCSF.isCaster then
						local isCasterWeapom = itemStatCache[ITEM_STAT_INTELLECT] or false
			--			print('T3', 'isCasterWeapom', isCasterWeapom)
			--			print('T4', 'specArg', specArg)
						
						if isCasterWeapom then
							if fullCSF.isCaster == MAIN_SPEC_ARG then
			--					print('T5', hasMainStat, CheckSpecArgs( specArg, MAIN_SPEC_ARG ), hasOffspecStat, CheckSpecArgs( specArg, OFF_SPEC_ARG ))
								return hasMainStat and CheckSpecArgs( specArg, MAIN_SPEC_ARG ) or false, hasOffspecStat and CheckSpecArgs( specArg, OFF_SPEC_ARG ) or false, true
							else
			--					print('T6', 'false hc', hasOffspecStat, CheckSpecArgs( specArg, OFF_SPEC_ARG ))
								return false, hasOffspecStat and CheckSpecArgs( specArg, OFF_SPEC_ARG ) or false, true
							end
						else
							if fullCSF.isCaster == MAIN_SPEC_ARG then
			--					print('T7', 'false hc', hasOffspecStat, CheckSpecArgs( specArg, OFF_SPEC_ARG ))
								return false, hasOffspecStat and CheckSpecArgs( specArg, OFF_SPEC_ARG ) or false, true
							else
			--					print('T8', hasMainStat, CheckSpecArgs( specArg, MAIN_SPEC_ARG ), hasOffspecStat, CheckSpecArgs( specArg, OFF_SPEC_ARG ))
								return hasMainStat and CheckSpecArgs( specArg, MAIN_SPEC_ARG ) or false, hasOffspecStat and CheckSpecArgs( specArg, OFF_SPEC_ARG ) or false, true
							end
						end
					else
				--		print('T9', hasMainStat, CheckSpecArgs( specArg, MAIN_SPEC_ARG ), hasOffspecStat, CheckSpecArgs( specArg, OFF_SPEC_ARG ))
						return hasMainStat and CheckSpecArgs( specArg, MAIN_SPEC_ARG ) or false, hasOffspecStat and CheckSpecArgs( specArg, OFF_SPEC_ARG ) or false, true
					end
				else
					return false, false, false
				end
		elseif equipSlot == 'INVTYPE_SHIELD' then			
			return fullCSF.useShield == MAIN_SPEC_ARG, fullCSF.useShield == OFF_SPEC_ARG, fullCSF.useShield
		elseif equipSlot == 'INVTYPE_HOLDABLE' then
			return fullCSF.useOffhand == MAIN_SPEC_ARG, fullCSF.useOffhand == OFF_SPEC_ARG, fullCSF.useOffhand
		elseif equipSlot == 'INVTYPE_HEAD' or
				equipSlot == 'INVTYPE_SHOULDER' or
				equipSlot == 'INVTYPE_ROBE' or
				equipSlot == 'INVTYPE_CHEST' or
				equipSlot == 'INVTYPE_BODY' or
				equipSlot == 'INVTYPE_WRIST' or
				equipSlot == 'INVTYPE_HAND' or
				equipSlot == 'INVTYPE_WAIST' or
				equipSlot == 'INVTYPE_LEGS' or
				equipSlot == 'INVTYPE_FEET'  then
				
			if classItemFiler[specID]['ARMOR'][subclass] then
				return true, true, true
			else					
				return false, false, false
			end
		elseif equipSlot == 'INVTYPE_NECK' or
				equipSlot == 'INVTYPE_CLOAK' or
				equipSlot == 'INVTYPE_FINGER' then
				
			wipe(itemStatCache)
			GetItemStats(link1, itemStatCache)
			
			local hasMainStat, hasOffspecStat = CheckMainStat(fullCSF['STATS'])
			--[==[
			local hasSpirit = itemStatCache[ITEM_STAT_SPIRIT] and true or false
			local hasBonusArmor = ns.CheckForContainTooltip(link1, PATTERN_EXTRAARMOR) and true or false-- itemStatCache[ITEM_STAT_BONUSARMOR] and true or false
			
			if hasSpirit then
				if fullCSF.isHealer then
					return fullCSF.isHealer == MAIN_SPEC_ARG, fullCSF.isHealer == OFF_SPEC_ARG, equipSlot == 'INVTYPE_CLOAK' and true or false
				else
					return false, false, equipSlot == 'INVTYPE_CLOAK' and true or false
				end
			elseif hasBonusArmor then
				if fullCSF.isTank then
					return fullCSF.isTank == MAIN_SPEC_ARG, fullCSF.isTank == OFF_SPEC_ARG, equipSlot == 'INVTYPE_CLOAK' and true or false
				else
					return false, false, equipSlot == 'INVTYPE_CLOAK' and true or false
				end
			else
				return hasMainStat, hasOffspecStat, equipSlot == 'INVTYPE_CLOAK' and true or false
			end
			]==]
			
			if ( equipSlot == 'INVTYPE_NECK' or equipSlot == 'INVTYPE_FINGER' ) and reqLevel > 100 then
				hasMainStat = true
				hasOffspecStat = true
			end
			
			return hasMainStat, hasOffspecStat, equipSlot == 'INVTYPE_CLOAK' and true or false
		end

		return true, false, false
	end
end

local ignoreRollIDs = {}

function ns:IsRollIDIgnored(rollID)
	
	if ignoreRollIDs[rollID] then
		if ignoreRollIDs[rollID] > GetTime() then
	--		ns.print('T', 'IsRollIDIgnored', rollID, ignoreRollIDs[rollID]-GetTime(), 's left')
			return true
		else
			ignoreRollIDs[rollID] = nil
	--		ns.print('T', 'IsRollIDIgnored', rollID, 'remove ignoring')
		end
	end
	
	return false
end

function ns:RemoveIgnoredRollID(rollID)
	ignoreRollIDs[rollID] = nil
end

function ns:ClearAllIgnoredRollIDs(guid)
	for rollID in pairs(ignoreRollIDs) do	
		if strfind(rollID, guid) then
			ignoreRollIDs[rollID] = nil
		end
	end
end

do
	-- Artifact Gems
	local function PrepareForScan()
		local ArtifactFrame = _G.ArtifactFrame

		if not ArtifactFrame or not ArtifactFrame:IsShown() then
			_G.UIParent:UnregisterEvent("ARTIFACT_UPDATE")
			if ArtifactFrame then
				ArtifactFrame:UnregisterEvent("ARTIFACT_UPDATE")
			end
		end
	end

	local function RestoreStateAfterScan()
		local ArtifactFrame = _G.ArtifactFrame

		if not ArtifactFrame or not ArtifactFrame:IsShown() then
			C_ArtifactUI.Clear()
			if ArtifactFrame then
				ArtifactFrame:RegisterEvent("ARTIFACT_UPDATE")
			end
			_G.UIParent:RegisterEvent("ARTIFACT_UPDATE")
		end
	end

	local gems = {}
	local lastUpdate = -1
	local init = true
	
	function ns:GetAtrifactGem(slot)
		if init or lastUpdate < GetTime() then
			lastUpdate = GetTime() + 10
			init = false
			wipe(gems)
			
			PrepareForScan()
			SocketInventoryItem(INVSLOT_MAINHAND)
			
			for relicSlotIndex=1, C_ArtifactUI.GetNumRelicSlots() do
				local lockedReason, relicName, relicIcon, relicLink = C_ArtifactUI.GetRelicInfo(relicSlotIndex);
				
				gems[relicSlotIndex] = relicLink
			end
			
			RestoreStateAfterScan()
		end
		
		
		return gems[slot]
	end
end


local function PrepareMessageToSend(rolltype, rollID, link, noteText, filterIndex )

	local classIndex, specID, classFileName, playerClass = ns.GetPlayerClassInfo()
	
	local item1, item2, item3 -- 3 slots for relics
	
	local name, link1, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(link)
	
	local itemID = ns.GetItemID(link1)
	
	if tierTokenItemType[itemID] then
		equipSlot = tierTokenItemType[itemID]
	end

	if IsArtifactRelicItem(itemID) then
		item1 = ns:GetAtrifactGem(1)
		item2 = ns:GetAtrifactGem(2)
		item3 = ns:GetAtrifactGem(3)
	elseif equipSlot and linkTypeItems[equipSlot] then		
		for i=1, #linkTypeItems[equipSlot] do
			if i == 1 then
				item1 = GetInventoryItemLink("player", linkTypeItems[equipSlot][i])
			else
				item2 = GetInventoryItemLink("player", linkTypeItems[equipSlot][i])
			end
		end		
	elseif ns.IsMountItem(subclass) and ( ns.IsMountExists(name) or ns.CheckForContainTooltip(link1, USED) ) then
		item1 = link1			
	end
	
	item1 = item1 and ns.ShortLink(item1) or 'NONE'
	item2 = item2 and ns.ShortLink(item2) or 'NONE'
	item3 = item3 and ns.ShortLink(item3) or 'NONE'
	
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")

	local note = noteText or ''
	
	local overall, equipped = GetAverageItemLevel()
	
	local rnd = fastrandom(1, 100)

	filterIndex = filterIndex or -1
	
	local msg = format('%s\n%s\n%s\n%s\n%s\n%s\n%d\n%d\n%d\n%d\n%d\n%s',rollID, rolltype, item1, item2, ( guildRankName or UNKNOWN ), note, equipped, rnd, classIndex, specID, filterIndex, item3)

	if rolltype == 0 then
		ns:SendMessage(msg, ns.channelNameLootRollSend)		
	else
		ns:SendMessage(msg, ns.channelNameLootRollSend)		
	end
	
end


local function ClickRoll(frame, button)
	if not frame:IsEnabled() then return end
	
	if button == 'RightButton' then	
		if ns.db.RightClickToHideAllRolls then	
			for i,f in ipairs(RollBars) do
				if f.rollID then 
					f.status.time = -1
				end
			end		
		end
		return
	end

--	ns.print(frame.rolltype, frame.parent.rollID)

	PrepareMessageToSend(frame.rolltype, frame.parent.rollID, frame.parent.button.link, frame.parent.noteText, frame.parent.filterIndex)
	
	ignoreRollIDs[frame.parent.rollID] = GetTime() + 60
	
	frame.parent.rollID = nil
	frame.parent.guid = nil
	frame.parent:Hide()	
end

local HideTip = ns.HideTip
local HideTip2  = ns.HideTip2
local SetTip = ns.SetTip
local SetItemTip = ns.SetItemTip
local ItemOnUpdate = ns.ItemOnUpdate
local LootClick = ns.LootClick

local function StatusUpdate(self, elapsed)
	self.time = ( self.time or 0 ) - elapsed
	
	if self.time < 0 then
		self.time = 0
		if self.parent.rollID then
		
			PrepareMessageToSend(0, self.parent.rollID, self.parent.button.link, nil,self.parent.button.filterIndex)
			
			self.parent.rollID = nil
			self.parent.guid = nil
			self.parent:Hide()	
		end
	end
	
	self:SetValue(self.time)
end

local function UpdateLootAnchors()
	local last = mover
	local height = FRAME_HEIGHT/2
	for i=1, #RollBars do
		local f = RollBars[i]		
		if f.rollID then
			f:ClearAllPoints()
				
			if not ns.db.RollsOnTop then --pos == "TOP" then
				f:SetPoint("TOP", last, "BOTTOM", height, -4)
			else
				f:SetPoint("BOTTOM", last, "TOP", height, 4)
			end
			height = 0
			last = f
		end
	end
end

ns.UpdateLootAnchors = UpdateLootAnchors

local function RollButton_OnMouseUp(f)
	if not forceEnabledButtons then
	if not f:IsEnabled() then return end
	end
	
--	f.Left:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
--	f.Right:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
--	f.Middle:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	
	f.name:SetPoint("CENTER", 0, 0)
end
local function RollButton_OnMouseDown(f)
	if not forceEnabledButtons then
	if not f:IsEnabled() then return end
	end
	
--	f.Left:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
--	f.Right:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
--	f.Middle:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	
	f.name:SetPoint("CENTER", 1, -1)
end

local function RollButton_HookScript_OnEnter(f)
	ns.CustomSetTexture(f.hightlightbg, 1, 1, 1, 0.2)
end

local function RollButton_HookScript_OnLeave(f)
	ns.CustomSetTexture(f.hightlightbg, 1, 1, 1, 0)
end

local function CreateRollButton(parent)
	local f = CreateFrame("Button", nil, parent)

	f:SetSize(FRAME_HEIGHT - 4, FRAME_HEIGHT - 4)
	f.rolltype = rolltype
	f.parent = parent
	f.tiptext = tiptext
	f:RegisterForClicks("RightButtonUp", 'LeftButtonUp')
	f:SetScript("OnEnter", SetTip)
	f:SetScript("OnLeave", HideTip)
	f:SetScript("OnClick", ClickRoll)
	f:SetScript("OnMouseUp", RollButton_OnMouseUp)
	f:SetScript('OnMouseDown', RollButton_OnMouseDown)
	f:HookScript("OnEnter", RollButton_HookScript_OnEnter)
	f:HookScript("OnLeave", RollButton_HookScript_OnLeave)

	f.bg = f:CreateTexture(nil, 'OVERLAY', nil, 1)
	f.bg:SetTexture(buttonsTexture) --0.4, 0.1, 0.1, 1)
	f.bg:SetPoint('TOPLEFT', f, 'TOPLEFT', 3, 0)
	f.bg:SetPoint('BOTTOMRIGHT', f, 'BOTTOMRIGHT', -3, 0)
	f.bg:SetVertexColor(0.4, 0.1, 0.1, 1)
	
	f.hightlightbg = f:CreateTexture(nil, 'OVERLAY', nil, 2)
	ns.CustomSetTexture(f.hightlightbg, 1, 1, 1, 0)	
	f.hightlightbg:SetPoint('TOPLEFT', f, 'TOPLEFT', 3, 0)
	f.hightlightbg:SetPoint('BOTTOMRIGHT', f, 'BOTTOMRIGHT', -3, 0)
	
	f.border = f:CreateTexture(nil, 'OVERLAY', nil, -1)
	ns.CustomSetTexture(f.border, 0, 0, 0, 1)
	f.border:SetPoint('TOPLEFT', f.bg, 'TOPLEFT', -1, 1)
	f.border:SetPoint('BOTTOMRIGHT', f.bg, 'BOTTOMRIGHT', 1, -1)
	
	f.SetState = function(self, enabled)
		if enabled then
			self:Enable()
			self.bg:SetVertexColor(0.8, 0.2, 0.2, 1)
		else
			if forceEnabledButtons then
				self:Enable()
			else
				self:Disable()
			end
			self.bg:SetVertexColor(0.5, 0.5, 0.5, 1)
		end
	end
	
	f.init = true
	f:SetScript('OnShow', function(self)		
		if self.init then
			self.init = false
			C_Timer.After(0.01, function()
				self:SetSize(self.name:GetStringWidth()+3+6, FRAME_HEIGHT - 10)
			end)
		end
	end)
	f.SetButtonOpts = function(self, ntex, ptex, htex, rolltype, tiptext, name, easyButton)
		if easyButton then
			self.rolltype = rolltype
			self.tiptext = tiptext
			self.name:SetText(name)

			self.bg:Show()
			self.border:Show()
			self.hightlightbg:Show()
			
			self:SetSize(self.name:GetStringWidth()+3+6, FRAME_HEIGHT - 10)
		else
			self:SetNormalTexture(ntex)
			if ptex then self:SetPushedTexture(ptex) end
			self:SetHighlightTexture(htex)

			self.bg:Hide()
			self.border:Hide()
			self.hightlightbg:Hide()
			
			self.rolltype = rolltype
			self.tiptext = tiptext
			self.name:SetText('')
			self:SetSize(FRAME_HEIGHT - 4, FRAME_HEIGHT - 4)
			self:SetScript('OnShow', nil)
		end
	end

	f.SetPassButton = function(self)
		self:SetButtonOpts("Interface\\Buttons\\UI-GroupLoot-Pass-Up", nil, "Interface\\Buttons\\UI-GroupLoot-Pass-Down", 0, PASS, 'Пас')
	end
	
	local txt = f:CreateFontString(nil, 'OVERLAY')
	txt:SetFont(ns.default_font, ns.default_font_size+2, ns.default_font_outline)
	txt:SetPoint("CENTER", 0, 0)
	txt:SetShadowColor(0,0,0,1)
	txt:SetShadowOffset(1,-1)
		
	f.name = txt
	
	return f, txt
end

local noteTextFrame = CreateFrame('Frame', nil, UIParent)
noteTextFrame:Hide()
noteTextFrame:SetSize(200, 70)
noteTextFrame:SetFrameStrata('HIGH')

noteTextFrame.bg = noteTextFrame:CreateTexture(nil, 'BACKGROUND')
noteTextFrame.bg:SetAllPoints()
ns.CustomSetTexture(noteTextFrame.bg, 0.1, 0.1, 0.1, 1)

noteTextFrame.left = noteTextFrame:CreateTexture(nil, 'OVERLAY')
noteTextFrame.left:SetPoint('TOPLEFT', noteTextFrame, 'TOPLEFT', 0, 0)
noteTextFrame.left:SetPoint('BOTTOMLEFT', noteTextFrame, 'BOTTOMLEFT', 0, 0)
noteTextFrame.left:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.left, 0,0,0,1)

noteTextFrame.right = noteTextFrame:CreateTexture(nil, 'OVERLAY')
noteTextFrame.right:SetPoint('TOPRIGHT', noteTextFrame, 'TOPRIGHT', 0, 0)
noteTextFrame.right:SetPoint('BOTTOMRIGHT', noteTextFrame, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.right:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.right, 0,0,0,1)

noteTextFrame.bottom = noteTextFrame:CreateTexture(nil, 'OVERLAY')
noteTextFrame.bottom:SetPoint('BOTTOMLEFT', noteTextFrame, 'BOTTOMLEFT', 0, 0)
noteTextFrame.bottom:SetPoint('BOTTOMRIGHT', noteTextFrame, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.bottom:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.bottom, 0,0,0,1)

noteTextFrame.top = noteTextFrame:CreateTexture(nil, 'OVERLAY')
noteTextFrame.top:SetPoint('TOPLEFT', noteTextFrame, 'TOPLEFT', 0, 0)
noteTextFrame.top:SetPoint('TOPRIGHT', noteTextFrame, 'TOPRIGHT', 0, 0)
noteTextFrame.top:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.top, 0,0,0,1)

noteTextFrame.editBox = CreateFrame("EditBox", nil, noteTextFrame)
noteTextFrame.editBox:SetPoint('TOP', noteTextFrame, 'TOP', 0, -10)
noteTextFrame.editBox:SetFontObject(ChatFontNormal)
noteTextFrame.editBox:SetFrameLevel(noteTextFrame:GetFrameLevel() + 1)
noteTextFrame.editBox:SetAutoFocus(false)
noteTextFrame.editBox:SetWidth(160)
noteTextFrame.editBox:SetHeight(20)
noteTextFrame.editBox:SetMaxLetters(30)
noteTextFrame.editBox:SetScript("OnEscapePressed", function(self)
	self:ClearFocus()
end)
noteTextFrame.editBox:SetScript("OnTextChanged", function(self, text)
	noteTextFrame.textNumLetters:SetText(self:GetNumLetters()..'/'..self:GetMaxLetters())
end)

noteTextFrame.textNumLetters = noteTextFrame:CreateFontString(nil, 'ARTWORK')
noteTextFrame.textNumLetters:SetFontObject(ChatFontNormal)
noteTextFrame.textNumLetters:SetSize(100,20)
noteTextFrame.textNumLetters:SetPoint('TOPRIGHT', noteTextFrame.editBox, 'BOTTOMRIGHT', 0, 2)
noteTextFrame.textNumLetters:SetJustifyH('RIGHT')


noteTextFrame.editBox.bg = noteTextFrame.editBox:CreateTexture(nil, 'BACKGROUND')
noteTextFrame.editBox.bg:SetAllPoints()
ns.CustomSetTexture(noteTextFrame.editBox.bg, 0.3, 0.3, 0.3, 1)

noteTextFrame.editBox.left = noteTextFrame.editBox:CreateTexture(nil, 'OVERLAY')
noteTextFrame.editBox.left:SetPoint('TOPLEFT', noteTextFrame.editBox, 'TOPLEFT', 0, 0)
noteTextFrame.editBox.left:SetPoint('BOTTOMLEFT', noteTextFrame.editBox, 'BOTTOMLEFT', 0, 0)
noteTextFrame.editBox.left:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.editBox.left, 0,0,0,1)

noteTextFrame.editBox.right = noteTextFrame.editBox:CreateTexture(nil, 'OVERLAY')
noteTextFrame.editBox.right:SetPoint('TOPRIGHT', noteTextFrame.editBox, 'TOPRIGHT', 0, 0)
noteTextFrame.editBox.right:SetPoint('BOTTOMRIGHT', noteTextFrame.editBox, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.editBox.right:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.editBox.right, 0,0,0,1)

noteTextFrame.editBox.bottom = noteTextFrame.editBox:CreateTexture(nil, 'OVERLAY')
noteTextFrame.editBox.bottom:SetPoint('BOTTOMLEFT', noteTextFrame.editBox, 'BOTTOMLEFT', 0, 0)
noteTextFrame.editBox.bottom:SetPoint('BOTTOMRIGHT', noteTextFrame.editBox, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.editBox.bottom:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.editBox.bottom, 0,0,0,1)

noteTextFrame.editBox.top = noteTextFrame.editBox:CreateTexture(nil, 'OVERLAY')
noteTextFrame.editBox.top:SetPoint('TOPLEFT', noteTextFrame.editBox, 'TOPLEFT', 0, 0)
noteTextFrame.editBox.top:SetPoint('TOPRIGHT', noteTextFrame.editBox, 'TOPRIGHT', 0, 0)
noteTextFrame.editBox.top:SetSize(1,1)
ns.CustomSetTexture(noteTextFrame.editBox.top, 0,0,0,1)


--[==[
noteTextFrame.editBox.bg = noteTextFrame.editBox:CreateTexture(nil, 'BACKGROUND')
noteTextFrame.editBox.bg:SetAllPoints()
ns.CustomSetTexture(noteTextFrame.editBox.bg, 0.4,0,0,0.7)
]==]

noteTextFrame.okey = CreateFrame('Button', nil, noteTextFrame)
noteTextFrame.okey:SetSize(54, 16)	
noteTextFrame.okey:SetPoint('CENTER', noteTextFrame, 'CENTER', -28, -20)
noteTextFrame.okey.bg = noteTextFrame.okey:CreateTexture(nil, 'OVERLAY', nil, 1)
noteTextFrame.okey.bg:SetAllPoints()
noteTextFrame.okey.bg:SetTexture(buttonsTexture)
noteTextFrame.okey.bg:SetVertexColor(0.6, 0.6, 0.2, 1)

noteTextFrame.okey.hightlightbg = noteTextFrame.okey:CreateTexture(nil, 'OVERLAY', nil, 2)
ns.CustomSetTexture(noteTextFrame.okey.hightlightbg, 1, 1, 1, 0.2)
noteTextFrame.okey.hightlightbg:SetPoint('TOPLEFT', noteTextFrame.okey, 'TOPLEFT', 0, 0)
noteTextFrame.okey.hightlightbg:SetPoint('BOTTOMRIGHT', noteTextFrame.okey, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.okey.hightlightbg:Hide()

noteTextFrame.okey.border = noteTextFrame.okey:CreateTexture()
noteTextFrame.okey.border:SetSize(1,1)
noteTextFrame.okey.border:SetPoint("TOPLEFT", noteTextFrame.okey.bg, 'TOPLEFT', -1, 1)
noteTextFrame.okey.border:SetPoint("BOTTOMRIGHT", noteTextFrame.okey.bg, 'BOTTOMRIGHT', 1, -1)
ns.CustomSetTexture(noteTextFrame.okey.border, 0, 0, 0, 1)

noteTextFrame.okey.text = noteTextFrame.okey:CreateFontString(nil, 'OVERLAY')
noteTextFrame.okey.text:SetPoint('CENTER', noteTextFrame.okey, 'CENTER', 0, 0)
noteTextFrame.okey.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
noteTextFrame.okey.text:SetText("OK")	
noteTextFrame.okey.text:SetShadowColor(0,0,0,1)
noteTextFrame.okey.text:SetShadowOffset(1,-1)
noteTextFrame.okey:SetScript('OnEnter', function(self)
	self.hightlightbg:Show()
end)
noteTextFrame.okey:SetScript('OnLeave', function(self)
	self.hightlightbg:Hide()
end)
noteTextFrame.okey:SetScript('OnMouseUp', function(self, button)
	self.text:SetPoint('CENTER', self, 'CENTER', 0, 0)
end)
noteTextFrame.okey:SetScript('OnMouseDown', function(self, button)
	self.text:SetPoint('CENTER', self, 'CENTER', 1, -1)
end)
noteTextFrame.okey:SetScript('OnClick', function(self)
	noteTextFrame:GetParent():GetParent().noteText = noteTextFrame.editBox:GetText()
	noteTextFrame:Hide()
	noteTextFrame.editBox:ClearFocus()
end)

noteTextFrame.cancel = CreateFrame('Button', nil, noteTextFrame)
noteTextFrame.cancel:SetSize(54, 16)	
noteTextFrame.cancel:SetPoint('CENTER', noteTextFrame, 'CENTER', 28, -20)
noteTextFrame.cancel.bg = noteTextFrame.cancel:CreateTexture(nil, 'OVERLAY', nil, 1)
noteTextFrame.cancel.bg:SetAllPoints()
noteTextFrame.cancel.bg:SetTexture(buttonsTexture)
noteTextFrame.cancel.bg:SetVertexColor(0.6, 0.6, 0.2, 1)

noteTextFrame.cancel.hightlightbg = noteTextFrame.cancel:CreateTexture(nil, 'OVERLAY', nil, 2)
ns.CustomSetTexture(noteTextFrame.cancel.hightlightbg, 1, 1, 1, 0.2)
noteTextFrame.cancel.hightlightbg:SetPoint('TOPLEFT', noteTextFrame.cancel, 'TOPLEFT', 0, 0)
noteTextFrame.cancel.hightlightbg:SetPoint('BOTTOMRIGHT', noteTextFrame.cancel, 'BOTTOMRIGHT', 0, 0)
noteTextFrame.cancel.hightlightbg:Hide()

noteTextFrame.cancel.border = noteTextFrame.cancel:CreateTexture(nil, 'OVERLAY', nil, -1)
noteTextFrame.cancel.border:SetSize(1,1)
noteTextFrame.cancel.border:SetPoint("TOPLEFT", noteTextFrame.cancel.bg, 'TOPLEFT', -1, 1)
noteTextFrame.cancel.border:SetPoint("BOTTOMRIGHT", noteTextFrame.cancel.bg, 'BOTTOMRIGHT', 1, -1)
ns.CustomSetTexture(noteTextFrame.cancel.border, 0, 0, 0, 1)

noteTextFrame.cancel.text = noteTextFrame.cancel:CreateFontString(nil, 'OVERLAY')
noteTextFrame.cancel.text:SetPoint('CENTER', noteTextFrame.cancel, 'CENTER', 0, 0)
noteTextFrame.cancel.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
noteTextFrame.cancel.text:SetText(CANCEL)	
noteTextFrame.cancel.text:SetShadowColor(0,0,0,1)
noteTextFrame.cancel.text:SetShadowOffset(1,-1)
noteTextFrame.cancel:SetScript('OnEnter', function(self)
	self.hightlightbg:Show()
end)
noteTextFrame.cancel:SetScript('OnLeave', function(self)
	self.hightlightbg:Hide()
end)
noteTextFrame.cancel:SetScript('OnMouseUp', function(self, button)
	self.text:SetPoint('CENTER', self, 'CENTER', 0, 0)
end)
noteTextFrame.cancel:SetScript('OnMouseDown', function(self, button)
	self.text:SetPoint('CENTER', self, 'CENTER', 1, -1)
end)

noteTextFrame.cancel:SetScript('OnClick', function(self)
	noteTextFrame:Hide()
	noteTextFrame.editBox:ClearFocus()
	noteTextFrame.editBox:SetText('')
	noteTextFrame:GetParent():GetParent().noteText = nil
end)

local function NoteButton_OnClick(self, button)	
	noteTextFrame:SetParent(self)
	noteTextFrame:SetPoint("CENTER", UIParent, 'CENTER', 0, 0)
	noteTextFrame:Show()	
	noteTextFrame.editBox:SetText(noteTextFrame:GetParent():GetParent().noteText or '')
end

local function CreateRollFrame()
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetSize(FRAME_WIDTH, FRAME_HEIGHT)
	frame:SetFrameStrata('HIGH')
	frame:SetFrameLevel(10)
	frame:Hide()
	frame:SetScript('OnShow', UpdateLootAnchors)
	frame:SetScript('OnHide', UpdateLootAnchors)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function()
		ns:StartClientSideMoving()
	end)
	frame:SetScript("OnDragStop", function()
		ns:StopClientSideMoving()
	end)

	local button = CreateFrame("Button", nil, frame)
	button:SetPoint("RIGHT", frame, 'LEFT', -4, 0)
	button:SetSize(FRAME_HEIGHT, FRAME_HEIGHT)

	button:SetScript("OnEnter", SetItemTip)
	button:SetScript("OnLeave", HideTip2)
--	button:SetScript("OnUpdate", ItemOnUpdate)
	button:SetScript("OnClick", LootClick)
	button:SetScript('OnEvent', SetItemTip)
	
	
	frame.button = button
	
	button.icon = button:CreateTexture(nil, 'OVERLAY')
	button.icon:SetAllPoints()
	button.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	
	button.RelicBorder = button:CreateTexture()
	button.RelicBorder:SetDrawLayer('OVERLAY', 1)
	button.RelicBorder:SetSize(FRAME_HEIGHT, FRAME_HEIGHT)
	button.RelicBorder:SetPoint('CENTER', button, 'CENTER', 0, 0)
	button.RelicBorder:SetTexCoord(0.04, 0.96, 0.04, 0.96)
	button.RelicBorder:SetTexture([[Interface\Artifacts\RelicIconFrame]]);

	button.bg = button:CreateTexture(nil, 'OVERLAY', nil, -1)
	button.bg:SetPoint('TOPLEFT', button.icon, 'TOPLEFT', -1, 1)
	button.bg:SetPoint('BOTTOMRIGHT', button.icon, 'BOTTOMRIGHT', 1, -1)
	ns.CustomSetTexture(button.bg, 0, 0, 0, 1)
	
	local iLvl = button:CreateFontString(nil, "OVERLAY")
	iLvl:SetFont(ns.default_font, ns.default_font_size+2, 'OUTLINE')
	iLvl:SetPoint("BOTTOM", button.icon, "BOTTOM", 0, 0)
	iLvl:SetSize(50, 50)
	iLvl:SetJustifyH("CENTER")
	iLvl:SetJustifyV("BOTTOM")	
	iLvl:SetTextColor(1, 1, 1, 1)
	iLvl:SetShadowColor(0,0,0,1)
	iLvl:SetShadowOffset(1,-1)
	iLvl:SetWordWrap(true)
	
	button.iLvl = iLvl
	
	local tfade = frame:CreateTexture(nil, "BORDER")
	tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, 0)
	tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 0)
	tfade:SetTexture([[Interface\Buttons\WHITE8x8]])
	tfade:SetBlendMode("ADD")
	tfade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .1, .1, .1, 0)

	local status = CreateFrame("StatusBar", nil, frame)
	status:SetPoint('TOPLEFT', button, 'TOPRIGHT', 4, 0)
	status:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 0, 0)
	status:SetScript("OnUpdate", StatusUpdate)
	status:SetFrameLevel(status:GetFrameLevel()-1)
	status:SetStatusBarTexture([[Interface\RaidFrame\Raid-Bar-Hp-Fill]])
	status:SetStatusBarColor(.8, .8, .8, .9)
	status.parent = frame
	frame.status = status

	status.bg = status:CreateTexture(nil, 'BACKGROUND')
	status.bg:SetSize(1,1)
	status.bg:SetAlpha(0.2)
	status.bg:SetAllPoints()
	status.bg:SetDrawLayer('BACKGROUND', 2)
	
	status.border = status:CreateTexture(nil, 'BACKGROUND')
	ns.CustomSetTexture(status.border, 0, 0, 0, 1)
	status.border:SetSize(1,1)
	status.border:SetPoint('TOPLEFT', status.bg, 'TOPLEFT', -1, 1)
	status.border:SetPoint('BOTTOMRIGHT', status.bg, 'BOTTOMRIGHT', 1, -1)
	status.border:SetDrawLayer('BACKGROUND', 1)
	--[[
	local spark = frame:CreateTexture(nil, "OVERLAY")
	spark:SetSize(14, FRAME_HEIGHT)
	spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	spark:SetBlendMode("ADD")
	status.spark = spark
	]]
	frame.buttons = {}

	frame.buttons[1] = CreateRollButton(frame)
	frame.buttons[2] = CreateRollButton(frame)
	frame.buttons[3] = CreateRollButton(frame)
	frame.buttons[4] = CreateRollButton(frame)
	frame.buttons[5] = CreateRollButton(frame)
	frame.buttons[6] = CreateRollButton(frame)
	frame.buttons[7] = CreateRollButton(frame)
	
	frame.UpdateButtonsState = function(self, need, offspec, transmog, upgrade, disabled)
		for i=1, #self.buttons do
			
			if self.buttons[i].buttonType == 'need' then
				self.buttons[i]:SetState( need )
			elseif self.buttons[i].buttonType == 'upgrade' then
				self.buttons[i]:SetState( upgrade )
			elseif self.buttons[i].buttonType == 'offspec' then
				self.buttons[i]:SetState( offspec )
			elseif self.buttons[i].buttonType == 'transmog' then
				self.buttons[i]:SetState( transmog )
			end
		end
	end
	
	frame.UpdateButtons = function(self, settings)
		for i=1, #self.buttons do
			self.buttons[i]:Hide()
		end
		
		local frameWidth = 0
		
		for i=1, #settings do
			
			local button = self.buttons[i]
			button:ClearAllPoints()
			
			if i == 1 then
				button:SetPoint("LEFT", self.button, "RIGHT", 5, 0)
			else
				button:SetPoint("LEFT", self.buttons[i-1], "RIGHT", 0, 0)
			end
			
			local ntex, ptex, htex = ns.LootRollIconTheme[settings[i].icon][1], ns.LootRollIconTheme[settings[i].icon][2], ns.LootRollIconTheme[settings[i].icon][3]
			
			local name, rolltype, tiptext = settings[i].name, i, settings[i].name
				
			button.buttonType = settings[i].tip
	
			button:SetButtonOpts(ntex, ptex, htex, rolltype, tiptext, name, easyButtons)
			button:Show()
			
			frameWidth = frameWidth + button:GetWidth() + 5
		end
		
		local passButton = self.buttons[#settings+1]
		passButton:SetPassButton()
		passButton:ClearAllPoints()
		passButton:SetPoint("LEFT", self.buttons[#settings], "RIGHT", 0, 0) --easyButtons and 0 or 2)
		passButton:Show()
		
		frameWidth = frameWidth + passButton:GetWidth() + 5
			
		self.fsloot:SetPoint("LEFT", passButton, "RIGHT", 0, 0)
		self.fsloot:SetPoint("RIGHT", self, "RIGHT", -5, 0)
		self.fsloot:SetSize(200, 10)
		self.fsloot:SetShadowColor(0,0,0,1)
		self.fsloot:SetShadowOffset(1,-1)
		self.fsloot:SetJustifyH("LEFT")
		
	--	FRAME_WIDTH
		
		if frameWidth < FRAME_WIDTH then
			frameWidth = FRAME_WIDTH
		end
		
		self:SetWidth(frameWidth)
	end
	
	local noteButton = CreateFrame('Button', nil, frame)
	noteButton:SetSize(14, 14)
	noteButton:SetNormalTexture("Interface/BUTTONS/UI-GuildButton-PublicNote-Up.png")
					-- :SetNormalTexture("Interface/BUTTONS/UI-GuildButton-PublicNote-Disabled.png")
	noteButton:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', -1, 2)
	noteButton:SetScript('OnClick', NoteButton_OnClick)
	
	frame.noteButton = noteButton
	
	local bop = frame:CreateFontString(nil, "ARTWORK")
	bop:SetFont(ns.default_font, ns.default_font_size+2, ns.default_font_outline)
	bop:SetPoint("LEFT", pass, "RIGHT", 0, 0)
	bop:SetJustifyH("LEFT")
	bop:SetShadowColor(0,0,0,1)
	bop:SetShadowOffset(1,-1)
	
	local loot = frame:CreateFontString(nil, "ARTWORK")
	loot:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	loot:SetPoint("LEFT", bop, "RIGHT", 0, 0)
	loot:SetPoint("RIGHT", frame, "RIGHT", -5, 0)
	loot:SetSize(200, 10)
	loot:SetJustifyH("LEFT")
	loot:SetShadowColor(0,0,0,1)
	loot:SetShadowOffset(1,-1)
	
	frame.fsloot = loot
	frame.fsbop = bop

	frame.rolls = {}

	return frame
end

local function GetFrame(rollID)
	for i,f in ipairs(RollBars) do	
	--	ns.inLinePrint('T3', rollID, f.rollID, ( f.rollID == rollID ) )
		if f.rollID == rollID then return f end
	end
	
	for i,f in pairs(RollBars) do
		if not f.rollID then return f end
	end
	
	local f = CreateRollFrame()
--	print('CreateNewFrame')
	tinsert(RollBars, f)
	return f
end

for i=1, 5 do
	GetFrame()
end

local lootButtonSettings = {}

function ns:UpdateRollButtons( frame )
	if frame then
		frame:UpdateButtons(lootButtonSettings)
	else
		for i,f in ipairs(RollBars) do
			f:UpdateButtons(lootButtonSettings)
		end
	end
end

function ns:UpdateRollButtonsState( frame, need, offspec, transmog, upgrade, disabled )
	if frame then
		frame:UpdateButtonsState(need, offspec, transmog, upgrade, disabled)
	else
		for i,f in ipairs(RollBars) do
			f:UpdateButtonsState(need, offspec, transmog, upgrade, disabled)
		end
	end
end

function ns:SetButtonSettings(info, author)
	--ns.print('T', 'SetButtonSettings', author)
	local lootData = { strsplit('\n', info) }
	local numButtons = #lootData / 4
	local lastIndex = 1
	
	ns:ResetButtonSettings()
	
	for i=1, numButtons do
		
		local name = lootData[lastIndex]; lastIndex = lastIndex + 1
		local tip  = lootData[lastIndex]; lastIndex = lastIndex + 1
		local arg  = lootData[lastIndex]; lastIndex = lastIndex + 1
		local icon = lootData[lastIndex]; lastIndex = lastIndex + 1
		
		
		lootButtonSettings[i] = { name = name, rollType = i, tip = tip, arg = arg, icon = tonumber(icon) }
		--print('T', 'Button', i, name, tip, arg, icon)
	end
end

function ns:ResetButtonSettings()
	wipe(lootButtonSettings)
end

function ns:GetButtonIDInfo(id)

	if id == 0 then	
		return L['PASS'], 'pass', 'normal'
	end
	
	if lootButtonSettings[id] then
		return lootButtonSettings[id].name, lootButtonSettings[id].tip, lootButtonSettings[id].arg
	end
	
	if ns.LootRollButtons[id] then
		return ns.LootRollButtons[id].name, ns.LootRollButtons[id].tip, ns.LootRollButtons[id].arg
	end
	
	return false 
end

function ns.GetButtonInfoList()
	if #lootButtonSettings > 0 then
		return lootButtonSettings
	end

	return ns.LootRollButtons
end

--[==[
local BindTypes = {
   [LE_ITEM_BIND_NONE] = 'None',
   [LE_ITEM_BIND_ON_ACQUIRE] = 'BoP',
   [LE_ITEM_BIND_ON_EQUIP] = 'BoE',
   [LE_ITEM_BIND_ON_USE] = 'BoU',
   [LE_ITEM_BIND_QUEST]   = 'QuestItem',
}
]==]

function ns.GetItemBindType(link)
	local _, _, _, _, _, _, _, _, _, _, _, _, _, bindType = GetItemInfo(link)
	
	return bindType
end

function ns.IsItemBoP(link)
	return ( ns.GetItemBindType(link) == LE_ITEM_BIND_ON_ACQUIRE )
end

function ns.IsBindTypeBoP(bind)
	return ( bind == LE_ITEM_BIND_ON_ACQUIRE )
end

function ns.IsItemBoE(link)
	return ( ns.GetItemBindType(link) == LE_ITEM_BIND_ON_EQUIP )
end

function ns.IsBindTypeBoE(bind)
	return ( bind == LE_ITEM_BIND_ON_EQUIP )
end

function ns.ShowLootItems_ItemGained(link, rollID, guid)
--	print('T', 'ShowLootItems_ItemGained', link, rollID, guid)
	
	local filterIndex = 0
	local enableNeed, enableOffspec, enableTransmog = ns.CheckItemFilter(link)
	local ignoreItem = false
	local enableUpgrade = enableNeed
	local itemID = ns.GetItemID(link)
	
	if enableFilterCache and currentClassCacheFilter and not currentClassCacheFilter[itemID] then
		currentClassCacheFilter[itemID] = {}
		currentClassCacheFilter[itemID][1] = enableNeed
		currentClassCacheFilter[itemID][2] = enableOffspec
		currentClassCacheFilter[itemID][3] = enableTransmog
	end
	
	if enableNeed then
		filterIndex = filterIndex + 1
	end
	if enableOffspec then
		filterIndex = filterIndex + 3
	end
	if enableTransmog then
		filterIndex = filterIndex + 5	
	end
			
	if not enableNeed and not enableOffspec and not enableTransmog then
		ignoreItem = true
	end
	
	if ns.db.AuraPassUnusableRolls and ignoreItem then
		ns.QueueFunction(2, PrepareMessageToSend, 0, rollID, link, nil, filterIndex )
		return
	end
	
	local frame = GetFrame(rollID)
	frame.link = link
	frame.rollID = rollID
	frame.guid = guid
	frame.filterIndex = filterIndex
	
	frame.status.time = 60
	frame.status:SetMinMaxValues(0, 60)
	frame.status:SetValue(60)

	local name, link1, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice,
		classID, subclassID, bindType = GetItemInfo(link)

	if tierTokenItemType[itemID] then equipSlot = tierTokenItemType[itemID] end
	if equipSlot and not linkTypeItems[equipSlot] then enableUpgrade = false end
	
	frame.button.link = link
	
	frame.button.icon:SetTexture(texture)
	
	if link and IsArtifactRelicItem(link) then
		frame.button.RelicBorder:Show()
	else
		frame.button.RelicBorder:Hide()
	end

	local itemInfoText = ''

	if ns.IsBindTypeBoE(bindType) then
		itemInfoText = '|cFFFFFF00BoE|r '
	elseif ns.IsBindTypeBoP(bindType) then
		itemInfoText = '|cFFFF0000BoP|r '
--	elseif ns.CheckForContainTooltip(link1, ITEM_BIND_TO_BNETACCOUNT) then
--		itemInfoText = 'BoA '
	end
	
	if ignoreItem then
		frame.button.icon:SetVertexColor(1, 0, 0, 1)
		
		frame.fsloot:SetText( ( ns.db.ShowItemLevel and itemInfoText or '')..'|cFFFF0000' ..name)
		frame.status:SetStatusBarColor(0.7, 0.1, 0.1, .7)
		ns.CustomSetTexture(frame.status.bg, 1, 0.1, 0.1, 1)
		frame.button.RelicBorder:SetVertexColor(1, 0.1, 0.1)
	else
		frame.button.icon:SetVertexColor(1, 1, 1, 1)
		
		local color = ITEM_QUALITY_COLORS[quality]
	
		frame.fsloot:SetText((  ns.db.ShowItemLevel and itemInfoText or '')..name)
		frame.status:SetStatusBarColor(color.r, color.g, color.b, .7)
		frame.button.RelicBorder:SetVertexColor(color.r, color.g, color.b)
		ns.CustomSetTexture(frame.status.bg, color.r, color.g, color.b, 1)
	end

	if ns.db.ShowItemLevel then
		if equipSlot and linkTypeItems[equipSlot] or IsArtifactRelicItem(itemID) then	
			frame.button.iLvl:Show()		
		else
			frame.button.iLvl:Hide()
		end
		frame.button.iLvl:SetText( ( iLevel and iLevel > 0 ) and iLevel or '' )
	else
		frame.button.iLvl:Show()
		frame.button.iLvl:SetText( itemInfoText )
	end

	frame.noteText = ''
	
	
	ns:UpdateRollButtons( frame )
	ns:UpdateRollButtonsState( frame, enableNeed, enableOffspec, enableTransmog, enableUpgrade, ignoreItem )
	
	frame:Show()
end

function ns:ShowLootItems(info, author)
	
--	ns.print('T', 'ShowLootItems', author)
	
	ns:ClearTimeoutLootBids()
	
	local lootData = { strsplit('\n', info) }
	local guid = lootData[1]

	for i=2, #lootData do 
		if lootData[i] ~= 'NONE' then
		--	ns.print('T', i-1, lootData[i])	
			
			local index = i-1
			local link = lootData[i]
			local rollID = guid..'\n'..index..'\n'..link
			
		--	ns.inLinePrint('T', rollID)
			
			if not ns:IsInstanceIgnored_Client() then 
				ns.QueueFunction(2, PrepareMessageToSend, 0, rollID, link)
			elseif not ns:IsRollIDIgnored(rollID) then		
		--			ns.inLinePrint('T2', rollID)
				ns.QueueForItemInfo(link, 'ShowLootItems_ItemGained', rollID, guid)				
			end
		end
	end
end


function ns:HideLootItems(info, author)

--	ns.print('T', 'HideLootItems', author)
	
	local lootData = { strsplit('\n', info) }
	
	if #lootData == 1 then	
		for i,f in ipairs(RollBars) do	
			if f.guid == lootData[1] then 			
				f.guid = nil
				f.rollID = nil
				f:Hide()	
			end
		end
	elseif #lootData == 3 then
		local guid = lootData[1]
		local index = lootData[2]
		local link = lootData[3]
	
		for i,f in ipairs(RollBars) do	
			if f.rollID == info then 			
				f.guid = nil
				f.rollID = nil
				f:Hide()	
			end
		end		
	--	ns.print('T', unpack(lootData))
	end
end


do
	local debugSpamThrottle = -1
	
	local GetNumSavedInstances = GetNumSavedInstances
	local GetSavedInstanceInfo = GetSavedInstanceInfo
	local GetSavedInstanceEncounterInfo = GetSavedInstanceEncounterInfo

	local deadBosses = {}
	local savedLockout = {}
	local fastCompare = {}
	
	function ns:Client_UpdateEncounterLockout()
		wipe(deadBosses)
		
		--UPDATE_INSTANCE_INFO 
		RequestRaidInfo();
		
		C_Timer.After(1, function()
			for i = 1, GetNumSavedInstances() do
				local name, instanceID, reset, difficultyId, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficulty, numEncounters, encounterProgress  = GetSavedInstanceInfo(i)
				local raidID = ns.Cache_GetInsanceIDByName(name)
				
				-- We're saved to the instance we're currently in
				if isRaid and raidID and ( difficultyId == 14 or difficultyId == 15 or difficultyId == 16 ) then
				
					local raidLockout = raidID..'_'..difficultyId
					
					if not deadBosses[raidLockout] then
						deadBosses[raidLockout] = {}
					end
					
					local index = 1
					local bossname, _, dead = GetSavedInstanceEncounterInfo(i, index)
					while bossname do
						
						local bossID = ns.Cache_GetBossIDByName(raidID, bossname)
						
						if bossID then
						--	print('LootHelperDebug', raidID, bossname, bossID, raidLockout, difficultyId)
							deadBosses[raidLockout][bossID] = locked and dead or false
							
						--	print('T', name, raidID, index, bossname, deadBosses[raidLockout][index])
						else
							if debugSpamThrottle < GetTime() then
					--			print('LootHelperDebug', raidID, bossname, bossID, raidLockout, difficultyId)
								debugSpamThrottle = GetTime() + 5
							end
						end
						
						index = index + 1
						bossname, _, dead = GetSavedInstanceEncounterInfo(i, index)
					end
				end
			end
		end)
	end
	
	function ns:Client_SendEncounterLockout(info, author)
		
		local raidID = info
		
		if not ns.testMode and not ns:IsPlayerMasterLooter(author) then return end
		
		ns:Client_UpdateEncounterLockout()
		
		C_Timer.After(2, function()
			if deadBosses[raidID] then
				local msg = raidID
				
				for bossID, locked in pairs(deadBosses[raidID]) do
					msg = msg..'\n'..bossID..'\n'..( locked and 'L' or 'F' )
				end
			
				ns:SendMessage(msg, ns.channelNameLockOut)	
			else
				ns:SendMessage(raidID..'\nNO_LOCKOUT', ns.channelNameLockOut)	
			end
		end)
	end
	
	function ns:Client_SendEncounterLockoutForce(raidID)	
		ns:Client_UpdateEncounterLockout()
		
		C_Timer.After(2, function()
			if deadBosses[raidID] then
				local msg = raidID				
				local msgt = raidID
				
				for bossID, locked in pairs(deadBosses[raidID]) do
				
					msg = msg..'\n'..bossID..'\n'..( locked and 'L' or 'F' )
					
					msgt = msgt..' '..bossID..' '..( locked and 'L' or 'F' )
				end
			
				ns:SendMessage(msg, ns.channelNameLockOut)	
			else
				ns:SendMessage(raidID..'\nNO_LOCKOUT', ns.channelNameLockOut)	

			end
		end)	
	end
	
	function ns:Client_ReceiveEncounterLockout(info, author)
		local lootData = { strsplit('\n', info) }
		
		local raidID = lootData[1]
		
	--	print('Client_ReceiveEncounterLockout', info, author)
		
		if not savedLockout[author] then
			savedLockout[author] = {}
		end
		
		if not savedLockout[author][raidID] then
			savedLockout[author][raidID] = {}
		end
		
		if not fastCompare[author] then
			fastCompare[author] = {}
		end
	
		if lootData[2] == 'NO_LOCKOUT' then
			savedLockout[author][raidID][0] = 'NO_LOCKOUT'
			fastCompare[author][raidID] = true
			
	--		print('T', author, raidID, 'NO_LOCKOUT')
		else
			savedLockout[author][raidID][0] = nil
			local index = 0
			for i=2, #lootData, 2 do 
				local bossID = tonumber(lootData[i])
				local locked = lootData[i+1]
				
				index = index + 1
				
				savedLockout[author][raidID][bossID] = locked
				
				if fastCompare[author][raidID] ~= false and locked == 'L' then
					fastCompare[author][raidID] = false
				end
				
		--		print('T', author, raidID, bossID, locked)
				
			end
		end
	end
	
	function ns:Client_GetEncounterLockoutInfoFast(raidID, player)
	
		if not raidID or not player then
			return -1
		end
		
		if fastCompare[player] then
			if fastCompare[player][raidID] == true then
				return 1
			elseif fastCompare[player][raidID] == false then
				return 2
			end
			
			return 0
		end

		return -1
	end
	
	function ns:Client_GetEncounterLockoutID()
		local name, instaceType, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID, instanceGroupSize = GetInstanceInfo()
		
		if instaceType == 'raid' and ( difficulty == 14 or difficulty == 15 or difficulty == 16 ) then
			local raidID = ns.Cache_GetInsanceIDByName(name)
			
			if raidID then			
				return raidID..'_'..difficulty
			end
		end
		
		return false
	end
	
	function ns:Client_GetEncounterLockoutInfo(raidID, player)
	
		if not raidID or not player then
			return -1
		end
		
		if savedLockout[player] then
			if savedLockout[player][raidID] then			
				if savedLockout[author][raidID][0] == 'NO_LOCKOUT' then					
					return 1
				else
					for bossID, locked in pairs(savedLockout[author][raidID]) do
						if locked then
							return 2
						end
					end
					
					return 1
				end
			end
			
			return 0
		end
		
		return -1
	end
	
	function ns:Client_FillGameTooltip(raidID, player, tooltip)
		
		local raid, difficult = strsplit('_', raidID)

		if raid then
			raid = tonumber(raid)
			
			local noLockout = ( savedLockout[player] and savedLockout[player][raidID] ) and savedLockout[player][raidID][0] == 'NO_LOCKOUT'

			for i=1, ns.Cache_GetNumBosses(raid) do
				local bossID = ns.Cache_GetBossIDByIndex(raid, i)
				local bossName = ns.Cache_GetBossNameByID(bossID)
				local locked = savedLockout[player] and savedLockout[player][raidID] and savedLockout[player][raidID][bossID]
				
				
				tooltip:AddDoubleLine('|cFFFFFFFF'..bossName..'|r', ( ( noLockout or locked == 'F' ) and '|cFF00FF00'..L['OPEN_LOCKOUT']..'|r' ) or ( locked == 'L' and '|cFFFF0000'..L['LOCKED_LOCKOUT']..'|r' ) or '|cFFFFFFFF???|r')
				
				
			--	print('T', i, bossName, bossID, locked, noLockout)
			end
		end
	end
	
	local timer = -1
	local eventHandler = CreateFrame('Frame')

	eventHandler:RegisterEvent('PLAYER_ENTERING_WORLD')
	eventHandler:RegisterEvent('GROUP_JOINED')
	eventHandler:RegisterEvent('RAID_INSTANCE_WELCOME')
	
	eventHandler:RegisterEvent('ZONE_CHANGED_NEW_AREA')
	eventHandler:RegisterEvent('ZONE_CHANGED')
	
	eventHandler:RegisterEvent('ENCOUNTER_END')
	
	eventHandler:SetScript('OnEvent', function(self, event, ...)
		
		local raidID = ns:Client_GetEncounterLockoutID()
		if not raidID then return end
		if timer > GetTime() then return end		
		timer = GetTime() + 5
	
		ns:Client_SendEncounterLockoutForce(raidID)	
	end)
	
end